import axios from 'axios';
import qs from 'qs';
let util = {

};


util.inOf = function (arr, targetArr) {
    let res = true;
    arr.map(item => {
        if (targetArr.indexOf(item) < 0) {
            res = false;
        }
    });
    return res;
};

util.oneOf = function (ele, targetArr) {
    if (targetArr.indexOf(ele) >= 0) {
        return true;
    } else {
        return false;
    }
};

util.showThisRoute = function (itAccess, currentAccess) {
    if (typeof itAccess === 'object' && itAccess.isArray()) {
        return util.oneOf(currentAccess, itAccess);
    } else {
        return itAccess === currentAccess;
    }
};

// util.getPathObjByName = function (vm, name) {
//     let pathObj = vm.$store.state.routers.filter((item) => {
//         if (item.children.length <= 1) {
//             return item.name === name;
//         } else {
//             let i = 0;
//             let childArr = item.children;
//             let len = childArr.length;
//             while (i < len) {
//                 if (childArr[i].name === name) {
//                     return true;
//                 }
//                 i++;
//             }
//             return false;
//         }
//     })[0];
//     return pathObj;
// };

util.openTaskFromBillOfAccount = function (data) {
    let singlePage = 'NO';
    let pageName = '';
    let origin = util.getOrigin();
    // let origin = ''; 
    // if(location.origin != location.href.split('/#')[0]){
    //   origin = location.href.split('/#')[0];
    // }else{
    //   origin = location.origin;
    // }
    let url = "";
    let startUserCode = "";
    let currentNodeName = data.currentTaskName;
    let taskDefinitionKey = data.actID;
    let currentTaskId = "";

    // 获取跳转URL
    url = data.taskLocalVariables[0].url;
    if (url) {
        let tr = url.split("?")[0];
        let tp = "create-payment-apply";
        if (!tr) {
            url = tp + url
        }
        url = origin + '/' + url;
    } else {
        $app.$Message.error('该条数据无跳转的URL参数');
        return;
    }
    startUserCode = data.processVariables[0].procStartUserLdapId;

    // 获取当前节点taskId
    currentTaskId = data.currentTaskID;

    if (process.env.API.env === "dev") {
        if (url.indexOf("8080") >= 0) {
            url = origin + url.split("8080")[1];
        } else if (url.indexOf("8081") >= 0) {
            url = origin + url.split("8081")[1];
        } else if (url.indexOf("8082") >= 0) {
            url = origin + url.split("8082")[1];
        } else if (url.indexOf("8083") >= 0) {
            url = origin + url.split("8083")[1];
        }
    }

    for (let item of routers) {
        if (item.name == /([^\?\/])+(?=\?)/.exec(url)[0]) {
            url = url.replace(/([^\?\/]+)(?=\?)/, "#/$1");
            singlePage = 'YES';
            pageName = item.name;
            break;
        }
    }
    //ap
    if (pageName == 'payment-plan') {
        pageName = 'create-payment-apply';
    }
    //gl
    if (pageName == 'payment-plan-gl') {
        pageName = 'create-payment-apply';
    }
    //|| $store.state.reimburseComment.vm.loginInfo.userCode
    let targetUrl = `${url}&singlePage=${singlePage}&pageName=${pageName}&claimId=${data.claimId || data.processVariables[0].formInstId}&claimNo=${data.claimNo}&categoryName=${data.categoryName}&taskNodeType=${data.taskNodeType}&catalogyCode=${data.catalogyCode}&currentTaskId=${currentTaskId}&taskDefinitionKey=${taskDefinitionKey}&currentNodeName=${currentNodeName}&userCode=${
        $store.state.userInfo.userCode || this.getUrlParams().userCode || ''}&startUserCode=${startUserCode}&actionType=${data.actionType}&fromPendingRead=${data.fromPendingRead}&fromPendingFeedBack=${data.fromPendingFeedBack}`;
    if (data.actID && targetUrl.indexOf("&actId=") < 0) {
        targetUrl = targetUrl +
            `&actId=${data.actID}`
    }
    if (data.openMode && targetUrl.indexOf("&openMode=") < 0) {
        targetUrl = targetUrl +
            `&openMode=${data.openMode}`
    }
    if (data.fromPendingFeedBack == 'Y' || data.fromAlreadyFeedBack == 'Y') {
        targetUrl = targetUrl +
            `&feedBackCreateUserCode=${data.feedBackCreateUserCode}&feedBackCreateUserName=${data.feedBackCreateUserName}&feedBackId=${data.id}`
    }

    if (data.fromPendingRead == 'Y' || data.fromAlreadyRead == 'Y') {
        targetUrl = targetUrl +
            `&readId=${data.id}`
    }

    if (data.source) {
        targetUrl = targetUrl +
            `&source=${data.source}`
    }
    if (pageName = 'create-payment-apply') {
        targetUrl = targetUrl +
            `&showPayment=true`
    }
    targetUrl = targetUrl + `&crctoken=${sessionStorage.crctoken}`
    window.open(targetUrl);

}

util.setCurrentPath = function (vm, name) {
    let pathList = []
    let i = $store.state.userMenu.findIndex((item) => {
        return item.actionUrl == name;
    })
    switch (name) {
        case 'feedback':
            pathList.unshift({
                title: '我的建议反馈',
                path: 'feedback',
                name: name
            })
            break;
    }
    if (!!~i) {
        pathList.unshift({
            title: $store.state.userMenu[i].menuName,
            path: $store.state.userMenu[i].actionUrl,
            name: name
        })
        util.getPathObjByName(pathList, $store.state.userMenu[i].menuModuleId);
    }
    pathList.unshift({
        title: '首页',
        path: '/home',
        name: 'home_index'
    })
    $store.commit('setCurrentPath', pathList);
    return pathList
};
util.getPathObjByName = function (list, menuId) {
    let i = $store.state.userMenu.findIndex((item) => {
        return item.menuId == menuId;
    })
    if (i > -1) {
        list.unshift({
            title: $store.state.userMenu[i].menuName,
            path: $store.state.userMenu[i].actionUrl,
            name: name
        })
        util.getPathObjByName(list, $store.state.userMenu[i].menuModuleId);
    }
}

util.openPage = function (vm, name, title) {
    vm.$router.push({
        name: name
    });
    let hasOpened = false;
    vm.pageTagsList.forEach((item, index) => {
        if (item.name === name) {
            hasOpened = true;
            vm.$store.commit('moveToSecond', index);
        }
    });
    if (!hasOpened) {
        vm.$store.commit('increateTag', { name: name, title: title });
    }
};
util.copyPros = function (source, target, excludeNames = [], callback = function () { }) {
    if (Object.prototype.toString.call(source) != '[object Object]') {
        console.error('source must be a object!');
        return;
    }
    if (Object.prototype.toString.call(target) != '[object Object]') {
        console.error('target must be a object!');
        return;
    }
    if (excludeNames && Object.prototype.toString.call(excludeNames) != '[object Array]') {
        console.error('excludeNames must be a array!');
        return;
    }
    for (let key of Object.keys(source)) {
        if (!excludeNames || !excludeNames.includes(key)) {
            source[key] = target[key];
        }
    }
    return source;
};

util.getUrlParams = function () {
    // !!!这里不能取location.search,因为如果值里面有#那么会有截断现象，只能取href
    let searchStr = location.href.split('?')[1];
    let result = {};
    if (!searchStr) {
        return result;
    } else {
        return qs.parse(searchStr);
    }
};

util.getDaysDiff = function (startDay, endDay) {
    return Math.floor((endDay - startDay) / 1000 / 60 / 60 / 24 + 0.5);
}

util.closeWebPage = function () {
    if (navigator.userAgent.indexOf("MSIE") > 0) {
        if (navigator.userAgent.indexOf("MSIE 6.0") > 0) {
            window.opener = null;
            window.close();
        } else {
            window.open('', '_top');
            window.top.close();
        }
    }
    else if (navigator.userAgent.indexOf("Firefox") > 0) {
        window.location.href = 'about:blank ';
    } else {
        window.opener = null;
        window.open('', '_self', '');
        window.close();
    }
}

export default util;
